import 'package:fireproof_annotation/fireproof_annotation.dart';
import 'package:flutter_fireproof/flutter_fireproof.dart';
import 'package:freezed_annotation/freezed_annotation.dart';

part 'badge.fire.dart';
part 'badge.freezed.dart';
part 'badge.g.dart';

@freezed
class BadgeBase with _$BadgeBase {
  const factory BadgeBase({
    required String name,
    required int points,
  }) = _BadgeBase;

  factory BadgeBase.fromJson(Map<String, dynamic> json) =>
      _$BadgeBaseFromJson(json);
}

@fireproof
class Badge extends _$Badge {
  final BadgeBase data;

  Badge({
    required this.data,
    required DocumentSnapshot snapshot,
  }) : super(snapshot);

  factory Badge.fromSnapshot(DocumentSnapshot snapshot) =>
      _$BadgeFromSnapshot(snapshot);
}
