import 'dart:async';

import 'package:analyzer/dart/element/element.dart';
import 'package:build/build.dart';
import 'package:fireproof/src/collection_generator.dart';
import 'package:fireproof_annotation/fireproof_annotation.dart'
    show Collection, Root;
import 'package:source_gen/source_gen.dart';

class RootGenerator extends GeneratorForAnnotation<Root> {
  @override
  FutureOr<String> generateForAnnotatedElement(
    Element element,
    ConstantReader annotation,
    BuildStep buildStep,
  ) {
    final stringBuffer = StringBuffer();

    if (element is! ClassElement) {
      throw StateError('Element annotated with $Root must be a class');
    }

    for (final field in element.fields) {
      if (TypeChecker.fromRuntime(Collection).hasAnnotationOf(field)) {
        // TODO: I need to get a constant reader here so I can read the fields

        final collectionClass = collectionGenerator(field);
        stringBuffer.write(collectionClass);
      }
    }

    // final library = await buildStep.resolver.libraryFor(
    //   await buildStep.resolver.assetIdForElement(oldLibrary.element),
    // );

    return stringBuffer.toString();
  }
}
